Bug 1268005 - Markup characters in constants are not saved in datamapper
Markup characters in constants are not saved in datamapper
Status: VERIFIED
Product: JBoss BPMS Platform 6
Classification: JBoss
Component: jBPM Designer (Show other bugs)
6.2.0
Unspecified Unspecified
high Severity high
: DR1
: 6.3.0
Assigned To: Jeremy Lindop
Kirill Gaevskii
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-01 10:38 EDT by Jeremy Lindop
Modified: 2016-02-09 04:14 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jeremy Lindop 2015-10-01 10:38:02 EDT
Description of problem:
Characters that are used in our internal markup for the json serialization of assignments are not handled correctly by the datamapper (or the old assignments editor). For example, if you include '=' or ',' in constants, then save, close and re-open the process, the constants are truncated.

See also:
https://bugzilla.redhat.com/show_bug.cgi?id=1244966
https://bugzilla.redhat.com/show_bug.cgi?id=1267857

Version-Release number of selected component (if applicable):
6.3.0.Final community

Steps to Reproduce:
1. Create a BP with a user task
2. Add some datainputs wiht constants which include chars =,[]
e.g. "http://google.com?q=test"
3. Save and re-open the process
4. Some of the constants will have been truncated



Expected results:


Additional info:
Comment 2 Jeremy Lindop 2015-10-22 12:39:35 EDT
Fixed by making sure markup characters in constants are encoded and decoded behind the sceneds, when necessary.

6.3.x
https://github.com/droolsjbpm/jbpm-designer/commit/897f12aafb3082358fcae1e29ee23d7616760563

master
https://github.com/droolsjbpm/jbpm-designer/commit/a89938ca70ed3143408eef56b676c785432be618
Comment 3 Kirill Gaevskii 2015-11-06 09:24:37 EST
Hi Jeremy,

Is it good enough to encode symbol "," to "##" and symbol "=" to "||"?

Also I can to imagine some constant string like "A |= B" which after decoding will be "A =| B" (the same situation with "#," which will be ",#") because of constant_value.replaceAll("||", "=").

And is it expected that if you will type some constant value with "\" symbol (like "C:\Documents\here") I/O Editor have no reaction for Save button click? 
Google Chrome shows:
"SEVERE [LogConfiguration] Exception caught: (SyntaxError) : Unexpected token d" error message at
"org.kie.workbench.KIEWebapp-0.js:32449".
Comment 5 Jeremy Lindop 2015-11-17 12:21:21 EST
Fixed by URLEncoding and URLDecoding constants when necessary.

master:
https://github.com/droolsjbpm/jbpm-designer/commit/4a949ed0e6d095770b741c2087eefed0e285c6b6
Comment 7 Kirill Gaevskii 2015-11-18 10:18:22 EST
There is no changes on 6.3.x branch and in current release.

P.S. Master branch works good.
Comment 8 Kris Verlaenen 2015-11-18 14:31:11 EST
Set to MODIFIED but changed target release to 6.3.0
Comment 9 Kirill Gaevskii 2016-02-09 04:14:13 EST
Verified for 6.3.DR1

Note You need to log in before you can comment on or make changes to this bug.